function HttpSocket() {
  this.socket = new XMLHttpRequest();
  this.openNexus = function(address, observer) {
    this.socket.open('GET', address);
    var self = this;
    this.socket.onreadystatechange = function() {
      if (self.socket.readyState == 4) {
        observer.onNexusDataAvailable(self.socket.status, self);
      }
    }
    this.socket.send(null);
  }
  this.openLogin = function(address, passport, password, challenge, observer) {
    this.socket.open('GET', address);
    var self = this;
    this.socket.onreadystatechange = function() {
      if (self.socket.readyState == 4) {
        observer.onLoginDataAvailable(self.socket.status, self);
      }
    }
    var authstring = 'Passport1.4 OrgVerb=GET,OrgURL=http%3A%2F%2Fmessenger%2Emsn%2Ecom,sign-in=';
    var headervalue = authstring + escape(passport) + ',pwd=' + escape(password) + ',' + challenge;
    this.socket.setRequestHeader('Authorization', headervalue);
    this.socket.send(null);
  }
}